Imports Microsoft.HomeServer.Controls
Imports Microsoft.HomeServer.Common.Client

Public Class MainTabUserControl

    Dim m_consoleServices As IConsoleServices

    Public Sub New()

        ' This call is required by the Windows Form Designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.

    End Sub

    Public Sub New(ByVal width As Integer, ByVal height As Integer, ByVal consoleServices As IConsoleServices)
        Me.New()

        Me.Width = width
        Me.Height = height
        Me.m_consoleServices = consoleServices
    End Sub

    Dim WithEvents timer1 As System.Timers.Timer
    Private Sub MainTabUserControl_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        timer1 = New System.Timers.Timer(100)
    
        Dim imageList As ImageList = New ImageList()
        imageList.ImageSize = New Size(32, 32)
        imageList.ColorDepth = ColorDepth.Depth32Bit

        'Add folder icons to image list
        imageList.Images.Add("Music", CommonImages.MusicIcon32x32)
        imageList.Images.Add("Videos", CommonImages.VideosIcon32x32)
        imageList.Images.Add("Public", CommonImages.PublicIcon32x32)
        imageList.Images.Add("Photos", CommonImages.PhotosIcon32x32)
        imageList.Images.Add("Folder", CommonImages.SharedFolderIcon32x32)

        'Add led icons to image list
        imageList.Images.Add("GrayIcon", CommonImages.GrayIcon32)
        imageList.Images.Add("GreenIcon", CommonImages.GreenIcon32)
        imageList.Images.Add("YellowIcon", CommonImages.YellowIcon32)
        imageList.Images.Add("RedIcon", CommonImages.RedIcon32)

        'Add duplication icons to image list
        imageList.Images.Add("DuplicationDisabled", CommonImages.DupDisabledIcon)
        imageList.Images.Add("DuplicationEnabled", CommonImages.DupEnabledIcon)

        FancyListView1.SmallImageList = imageList

        Dim lvi As ListViewItem
        Dim r As New Random()

        For x As Integer = 0 To 9

            lvi = New ListViewItem()
            lvi.Text = "Folder #" + x.ToString()
            'Randomly select a folder icon from the imagelist
            lvi.ImageIndex = r.Next(0, 5)

            'Status icon
            Dim isi As New FancyListView.ImageSubItem
            'Randomly select a status icon from the imagelist
            isi.Text = imageList.Images.Keys(r.Next(5, 9))
            isi.ImageKey = isi.Text

            'Add status icon to ListViewItem
            lvi.SubItems.Add(isi)

            'Duplication icon
            Dim isi1 As New FancyListView.ImageSubItem()
            If r.Next(0, 2) = 0 Then
                isi1.ImageKey = "DuplicationDisabled"
            Else
                isi1.ImageKey = "DuplicationEnabled"
            End If

            'Add duplication icon to ListViewItem
            lvi.SubItems.Add(isi1)

            'Add new ListViewItem to FancyListView
            FancyListView1.Items.Add(lvi)
        Next

        timer1.Start()
    End Sub

    Dim currentItem As ListViewItem = Nothing
    Sub timer1_Elapsed(ByVal sender As Object, ByVal e As System.Timers.ElapsedEventArgs) Handles timer1.Elapsed

        'Required to make sure that update is happening on proper thread
        If Me.InvokeRequired Then
            MyBase.Invoke(New Timers.ElapsedEventHandler(AddressOf Me.timer1_Elapsed), New Object() {sender, e})
            Return
        End If

        If Me.Parent Is Nothing Then
            Return
        End If

        If currentItem Is Nothing Then
            currentItem = FancyListView1.Items(0)
        End If

        Dim fbsi As FancyListView.FilledBarSubItem

        'if no FilledBarSubItem exists, create one
        If currentItem.SubItems.Count = 3 Then
            fbsi = New FancyListView.FilledBarSubItem()

            'Randomly select warning and critical thresholds
            Dim r As New Random()
            Dim warning As Integer = r.Next(0, 100)
            Dim critical As Integer = r.Next(warning, 100)

            fbsi.WarningPercentage = warning
            fbsi.CriticalPercentage = critical

            fbsi.WarningColor = Color.Orange
            fbsi.CriticalColor = Color.Red

            currentItem.SubItems.Add(fbsi)
        Else
            fbsi = CType(currentItem.SubItems(3), FancyListView.FilledBarSubItem)
        End If

        If fbsi.PercentageFilled = 100 Then

            'Remove current FilledBarSubItem
            currentItem.SubItems.Remove(fbsi)

            'Find location of current item and increment
            Dim newLocation As Integer = FancyListView1.Items.IndexOf(currentItem) + 1

            'If new item index is higher than avalible items, wrap
            If (newLocation >= FancyListView1.Items.Count) Then
                newLocation = 0
            End If
            'Specify next/currentItem
            currentItem = FancyListView1.Items(newLocation)

            'Recall this method with new currentItem
            timer1_Elapsed(sender, e)
            Return
        End If

        'Increment current percentage
        fbsi.PercentageFilled += 1
        fbsi.Text = fbsi.PercentageFilled.ToString() + "%"

        'Locate index of currentItem
        Dim index As Integer = FancyListView1.Items.IndexOf(currentItem)
        'Redraw just the currentItem
        FancyListView1.RedrawItems(index, index, False)
    End Sub
End Class